<?php

# This program is in the public domain within the United States. Additionally,
# we waive copyright and related rights in the work worldwide through the CC0
# 1.0 Universal public domain dedication, which can be found at
# http://creativecommons.org/publicdomain/zero/1.0/


# require_once() this file instead of messages.php if you'd like to store
# save/restore messages in the session accross redirect()s. That's all you have
# to do. These functions are called when needed (from redirect() and
# display_messages()) if they are defined.

# see messages.php for documentation on how to use it.

require_once(__DIR__.'/'.'session.php');
require_once(__DIR__.'/'.'messages.php');

function session_save_messages() {
	if(!isset($GLOBALS['wfpl_messages'])) {
		return;
	}
	if(!is_array($GLOBALS['wfpl_messages'])) {
		return;
	}
	if(!count($GLOBALS['wfpl_messages'])) {
		return;
	}

	init_session();
	session_set('wfpl_messages', json_encode($GLOBALS['wfpl_messages']));
}

function session_restore_messages() {
	if(session_exists()) {
		$messages = session_get('wfpl_messages');
		if($messages !== false) {
			session_clear('wfpl_messages');
			$messages = json_decode($messages, true);
			if ($messages !== null) {
				return $messages;
			}
		}
	}
	return array();
}
